# Copyright (C) 2004-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

.SUFFIXES:

amd64: ASM_DEMO.EXE
	"$(MAKEDIR)\$**"

i386: ASM_DEMO.COM
	"$(MAKEDIR)\$**"

ASM_DEMO.DOS: ASM_DEMO.MAK
	CERTUTIL.EXE /DecodeHex /F /V << $@
4D 5A 90 00 01 00 00 00 04 00 00 00 FF FF 00 00   MZ..............
E0 00 00 00 43 00 00 00 40 00 00 00 00 00 00 00   ....C...@.......
00 00 00 00 19 57 04 27 00 00 00 00 00 00 00 00   .....W.'........
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00   ................
28 43 29 6F 70 79 72 69 67 68 74 20 32 30 30 34   (C)opyright 2004
2D 32 30 32 34 2C 20 53 74 65 66 61 6E 20 4B 61   -2024, Stefan Ka
6E 74 68 61 6B 20 3C 73 74 65 66 61 6E 2E 6B 61   nthak <stefan.ka
6E 74 68 61 6B 40 6E 65 78 67 6F 2E 64 65 3E 0D   nthak@nexgo.de>.
0A 07 24 0E 1F 33 D2 B4 09 CD 21 B8 01 4C CD 21   .....3....!..L.!
<<NOKEEP

ASM_DEMO.OMF: ASM_DEMO.MAK
	ML.EXE /Brepro /Fo$@ /nologo /omf /Ta<< /W3 /X
; Copyright (C) 2004-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.model	tiny

e_header struct				; DOS .EXE header
e_magic	word	5A4Dh			; magic number "MZ"
e_cblp	word	stop - header		; bytes on last page of file
e_cp	word	1			; pages in file
e_crlc	word	0			; number of relocation table entries
e_cparhdr word	sizeof header / 16	; size of header in paragraphs
e_minalloc word	0			; minimum extra paragraphs needed
e_maxalloc word	65535			; maximum extra paragraphs needed
e_ss	word	0			; initial (PSP relative) SS value
e_sp	word	stack - header		; initial (SS relative) SP value
e_csum	word	0			; checksum
e_ip	word	sizeof message		; initial (CS relative) IP value
e_cs	word	0			; initial (PSP relative) CS value
e_lfarlc word	sizeof header		; file address of relocation table
e_ovno	word	0			; overlay number
e_res	word	4 dup (0)		; reserved words
e_oemid	word	5719h			; OEM identifier
e_oeminfo word	2704h			; OEM information
e_res2	word	10 dup (0)		; reserved words
e_lfanew dword	0			; file address of new exe header
e_header ends

	.code

header	e_header <>

message	byte	"(C)opyright 2004-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>", 0Dh, 0Ah, 07h, 24h

start:
	push	cs
	pop	ds
	xor	dx, dx
	mov	ah, 09h
	int	21h

	mov	ax, 4C01h
	int	21h
stop:
	dword	20 dup (?)
stack:
	end	start
<<NOKEEP

ASM_DEMO.COM: ASM_DEMO.386 ASM_DEMO.DOS
	LINK.EXE /LINK /BREPRO /DYNAMICBASE /ENTRY:startup /LARGEADDRESSAWARE /MACHINE:I386 /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NODEFAULTLIB /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:5.1 /OUT:$@ /RELEASE /STACK:65536 /STUB:ASM_DEMO.DOS /SUBSYSTEM:CONSOLE /SWAPRUN:CD,NET /TEST /VERSION:0.815 ASM_DEMO.386

ASM_DEMO.386: ASM_DEMO.MAK
	ML.EXE /Brepro /Cp /Cx /c /Fo$@ /Gy /nologo /safeseh /Ta<< /W3 /X
; Copyright (C) 2004-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.model	flat, C

; https://msdn.microsoft.com/en-us/library/dn449700.aspx

_nt_tib	struct	4			; thread information block
chain	dword	?			; address of first exception registration record
base	dword	?			; stack base
limit	dword	?			; stack limit
	dword	?			; address of subsystem thread information block
fiber	dword	?			; fiber data
pointer	dword	?			; arbitrary user pointer
self	dword	?			; address of _nt_tib
_nt_tib	ends

; https://msdn.microsoft.com/en-us/library/ms680328.aspx

_lcu_32	struct	4
	dword	sizeof _lcu_32
	dword	"DEMO"			; 2006-04-18 20:34:23 UTC
	word	0, 815
	dword	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	word	0
	word	0800h			; "LINK.EXE /DEPENDENTLOADFLAG:2048"
	dword	0
	dword	offset __security_cookie
	dword	offset __safe_se_handler_table
	dword	offset __safe_se_handler_count
	dword	0, 0, 0, 0, 0
	word	0, 0
	dword	0, 0
_lcu_32	ends

; https://msdn.microsoft.com/en-us/library/9a89h429.aspx

	extern	__safe_se_handler_count :abs
	extern	__safe_se_handler_table :ptr proc

	.safeseh handler

	.fardata?			; same as .data?

	.fardata			; same as .data

	.data?

	.data

__security_cookie \
	dword	3141592654

	.const

	public	_load_config_used
_load_config_used \
	_lcu_32	<>

	.code

handler	proc	private

	ud2
	ret

handler	endp

	extern	__ImageBase :dword	; address of module

startup	proc	public

	xor	ecx, ecx
	inc	ecx			; in 64-bit mode, 41h is REX.B prefix
					; which LOOP but ignores!
	loop	amd64
i386:
if 0 ; NOT SUPPORTED
	mov	eax, eip		; eax = program counter
elseif 0
	lea	eax, $$			; eax = program counter
elseif 0
	call	@f
@@:
	pop	eax			; eax = program counter
					;     = current address
elseif 0
	mov	eax, esp		; eax = stack pointer
elseif 0
	pop	eax			; eax = return address
	push	eax
elseif 0
	pushfd
	pop	eax			; eax = flags register
elseif 0
	rdtscp				; eax = low dword of time stamp counter,
					; edx = high dword of time stamp counter
	xor	eax, edx
elseif 0
	rdtscp				; eax = low dword of time stamp counter,
					; edx = high dword of time stamp counter,
					; ecx = low dword of processor id
	xor	eax, ecx
	xor	eax, edx
elseif 0
	smsw	eax			; eax = machine status word alias CR0
elseif 0
	push	eax
	fnstsw	[esp]
	fnstcw	[esp+2]
	pop	eax			; eax = FPU control and status words
elseif 0
	push	eax
	stmxcsr	[esp]
	pop	eax			; eax = MMX control and status register
elseif 0
	assume	fs :flat
	mov	eax, fs:[_nt_tib.limit]	; eax = (current) stack limit
elseif 0
	lea	eax, offset startup	; eax = address of startup()
elseif 0
	lea	eax, proc ptr startup	; eax = address of startup()
elseif 0
	lea	eax, offset __ImageBase	; eax = address of module
elseif 0
	lea	eax, [__ImageBase]	; eax = address of module
elseif 0
	mov	eax, __security_cookie	; eax = stack cookie
else
	xor	eax, eax
	cdq
;;	tzcnt	eax, eax
	byte	0F3h
	bsf	eax, eax
	setnz	al			; al = (tzcnt = rep bsf <> bsf) ? 1 : 0
	lzcnt	edx, edx
	setnz	ah			; ah = (lzcnt = rep bsr <> bsr) ? 1 : 0
endif
	ret
amd64:
	ud2

startup	endp
	end	startup			; writes "/ENTRY:startup" to '.drectve' section
<<NOKEEP

ASM_DEMO.EXE: ASM_DEMO.AMD ASM_DEMO.DOS
	LINK.EXE /LINK /BREPRO /DYNAMICBASE /ENTRY:startup /LARGEADDRESSAWARE /MACHINE:AMD64 /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NODEFAULTLIB /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:5.2 /OUT:$@ /RELEASE /STACK:65536 /STUB:ASM_DEMO.DOS /SUBSYSTEM:CONSOLE /SWAPRUN:CD,NET /TEST /VERSION:0.815 ASM_DEMO.AMD

ASM_DEMO.AMD: ASM_DEMO.MAK
	ML64.EXE /Brepro /Cp /Cx /c /Fo$@ /Gy /nologo /Ta<< /W3 /X
; Copyright (C) 2004-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

; https://msdn.microsoft.com/en-us/library/dn449700.aspx

_nt_tib	struct	8			; thread information block
chain	qword	?			; address of first exception registration record
base	qword	?			; stack base
limit	qword	?			; stack limit
	qword	?			; address of subsystem thread information block
fiber	qword	?			; fiber data
pointer	qword	?			; arbitrary user pointer
self	qword	?			; address of _nt_tib
_nt_tib	ends

; https://msdn.microsoft.com/en-us/library/ms680328.aspx

_lcu_64	struct	8
	dword	sizeof _lcu_64
	dword	"DEMO"			; 2006-04-18 20:34:23 UTC
	word	0, 815
	dword	0, 0, 0
	qword	0, 0, 0, 0, 0, 0
	dword	0
	word	0
	word	0800h			; "LINK.EXE /DEPENDENTLOADFLAG:2048"
	qword	0
	qword	offset __security_cookie
	qword	0, 0
	qword	0, 0, 0, 0
	dword	0
	word	0, 0
	dword	0, 0
_lcu_64	ends

	.data?

	.data

__security_cookie \
	qword	3141592653589793241 shr 16

	.const

	public	_load_config_used
_load_config_used \
	_lcu_64	<>

	extern	__ImageBase :qword	; address of module

	.code

startup	proc	public

	xor	ecx, ecx
	byte	41h			; in 32-bit mode, 41h is INC ECX;
					; in 64-bit mode, 41h is REX.B prefix,
					; which LOOP but ignores!
	loop	amd64

	ud2
amd64:
if 0 ; NOT SUPPORTED
	mov	rax, rip		; rax = program counter
elseif 0
	lea	rax, $$			; rax = program counter
elseif 0
	call	@f
@@:
	pop	rax			; rax = program counter
					;     = current address
elseif 0
	mov	rax, rsp		; rax = stack pointer
elseif 0
	pop	rax			; rax = return address
	push	rax
elseif 0
	pushfq
	pop	rax			; rax = flags register
elseif 0
	rdtsc				; rax = low dword of time stamp counter,
					; rdx = high dword of time stamp counter
	xor	rax, rdx
elseif 0
	rdtscp				; rax = low dword of time stamp counter,
					; rdx = high dword of time stamp counter,
					; rcx = low dword of processor id
	xor	rax, rcx
	xor	rax, rdx
elseif 0
	smsw	eax			; rax = machine status word alias CR0
elseif 0
;;	xor	rax, rax
	push	rax
	fnstsw	[rsp]
	fnstcw	[rsp+2]
	pop	rax			; rax = FPU control and status words
elseif 0
;;	xor	rax, rax
	push	rax
	stmxcsr	[rsp]
	pop	rax			; rax = MMX control and status register
elseif 0
;;	assume	gs :flat
	mov	rax, gs:[_nt_tib.limit]	; rax = (current) stack limit
elseif 0
	lea	rax, offset startup	; rax = address of startup()
elseif 0
	lea	rax, proc ptr startup	; rax = address of startup()
elseif 0
	lea	rax, offset __ImageBase	; rax = address of module
elseif 0
	lea	rax, [__ImageBase]	; rax = address of module
elseif 0
	mov	rax, __security_cookie	; rax = stack cookie
else
	xor	eax, eax
	cdq
;;	tzcnt	eax, eax
	byte	0F3h
	bsf	eax, eax
	setnz	al			; al = (tzcnt = rep bsf <> bsf) ? 1 : 0
	lzcnt	edx, edx
	setnz	ah			; ah = (lzcnt = rep bsr <> bsr) ? 1 : 0
endif
	ret

startup	endp
	end
<<NOKEEP
